import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Rocket here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Rocket  extends SmoothMover
{
    private int numHits;
    
    public Rocket() {
        super(new Vector(0, 5.0));
        numHits = 0;
    }
    
    /**
     * Act - do whatever the Rocket wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkForKeyPress();
        move();
        checkForBarrels();
    }  
    
    private void checkForKeyPress() {
        if(Greenfoot.isKeyDown("left")) {
            setRotation(getRotation() - 1);
            getMovement().setDirection(getRotation());
        }
        
        if(Greenfoot.isKeyDown("right")) {
            setRotation(getRotation() + 1);
            getMovement().setDirection(getRotation());
        }
    }
    
    private void checkForBarrels() {
         Actor actor = getOneIntersectingObject(Barrel.class);
         if(actor != null) {
            setRotation(getRotation() + 180);
            getMovement().setDirection(getRotation());
            numHits = numHits + 1;
            
            //add the code to move all the barrels down 5 pixels
            java.util.List<Barrel> listOfBarrels = getWorld().getObjects(Barrel.class);
            
            for(Barrel sue: listOfBarrels) {
                sue.setLocation(sue.getX(), sue.getY() + 5);
            }
            
            if(numHits > 10) {
                for(Barrel b: listOfBarrels) {
                    b.setImage(new GreenfootImage("flower2.png"));
                }
            }
            
            if(numHits > 30) {
                //for(Barrel b: listOfBarrels) {
                    //getWorld().removeObject(b);
                //}
                getWorld().removeObjects(listOfBarrels);
            }
         }
    }
}
    
